#include <stdlib.h>
#include "integerio.h"

#define STACKSIZE 1024

#define PUSH(value) \
if(sp < STACKSIZE) \
{ \
   stack[sp] = value;\
   sp++;\
}\
else\
{\
   printf("Stack overflow error\n");\
}

#define POP_FAIL(varname) \
if(sp > 0)\
{\
   sp--;\
   varname = stack[sp];\
}\
else\
{\
   printf("Stack underflow error\n");\
   break;\
}

int main(void)
{
   int num, arg1, arg2, i;
   int stack[STACKSIZE];
   int sp = 0, in_base = 10, out_base = 10;
   
   SkipSpace();
   while(LookChar()!=EOF)
   {
      if(int_available(in_base))
      {
	 num = read_int_base(in_base);
	 PUSH(num);
      }
      else
      {
	 switch(GetChar())
	 {
	 case 'o':
	       POP_FAIL(num);
	       if(num < 2 || num >16)
	       {
		  printf("Only bases 2-16 (decimal) supported\n");
	       }
	       else
	       {
		  out_base = num;
	       }
	       break;
	 case 'i':
	       POP_FAIL(num);
	       if(num < 2 || num >16)
	       {
		  printf("Only bases 2-16 (decimal) supported\n");
	       }
	       else
	       {
		  in_base = num;
	       }
	       break;
	 case 'p':
	       POP_FAIL(num);
	       write_int_base(num,out_base);
	       putchar('\n');
	       PUSH(num);
	       break;	       
	 case '+':
	       POP_FAIL(arg2);
	       POP_FAIL(arg1);
	       num = arg1+arg2;
	       PUSH(num);
	       break;
	 case '-':
	       POP_FAIL(arg2);
	       POP_FAIL(arg1);
	       num = arg1-arg2;
	       PUSH(num);
	       break;
	 case '*':
	       POP_FAIL(arg2);
	       POP_FAIL(arg1);
	       num = arg1*arg2;
	       PUSH(num);
	       break;
	 case '/':
	       POP_FAIL(arg2);
	       POP_FAIL(arg1);
	       num = arg1/arg2;
	       PUSH(num);
	       break;
	 case '%':
	       POP_FAIL(arg2);
	       POP_FAIL(arg1);
	       num = arg1%arg2;
	       PUSH(num);
	       break;
	 case 'S':
	       for(i=0; i<sp; i++)
	       {
		  write_int_base(stack[i],out_base);
		  putchar(' ');
	       }
	       putchar('\n');
	       break;
	 case 'P':
	       printf("Input base (decimal): %d  Output Base (decimal): %d\n",
		     in_base,out_base);
	       break;
	 default:
	       printf("Unknown operand\n");
	 }
      }
      SkipSpace();
   }   
   return EXIT_SUCCESS;
}





